'--------------------------------------------------------------------------------
'  CableModem.vbs (v1.0)
'--------------------------------------------------------------------------------
'
' Retreives your cable modem tx and rx signal intensity level (in dBmV).
' useful for users of Webstar 2100 series cable modems from Scientific Atlanta, Inc.
' e.g. Used in Brazil by some subscribers of Virtua cable ISP.
'
' Results are always displayed in dBmV with a dot "." as decimal separator.
'
'								-joaosantiago
'--------------------------------------------------------------------------------

dim htmlResult

	htmlResult = ReturnHTML("http://192.168.100.1/system.asp")


Function getRxlevel ()

	leftMark = instr(htmlResult, "Receive Power Level" ) + 99

	rightMark = instr( htmlResult, "Receive Power Level" ) + 102

	if rightMark > 0 Then

		'grabs the intensity level
		getRxlevel = mid( htmlResult, leftMark, rightMark - leftMark + 1)

	else
		getRxlevel = "ERROR"

	end if

End Function


Function getTxlevel ()

	leftMark = instr(htmlResult, "Transmit Power Level" ) + 100

	rightMark = instr( htmlResult, "Transmit Power Level" ) + 103

	if rightMark > 0 Then

		'grabs the intensity level
		getTxlevel = mid( htmlResult, leftMark, rightMark - leftMark + 1)

	else
		getTxlevel = "ERROR"

	end if

End Function


Private Function ReturnHTML(sURL)
	Dim objXMLHTTP,HTML
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
	objXMLHTTP.Open "GET", sURL, False
	objXMLHTTP.Send
	HTML = objXMLHTTP.responseBody
	Set objRS = CreateObject("ADODB.Recordset")
	objRS.Fields.Append "txt", 200, 45000, &H00000080
	objRS.Open
	objRS.AddNew
	objRS.Fields("txt").AppendChunk HTML
	ReturnHTML = objRS("txt").Value
	objRS.Close
	Set objRS = Nothing
	Set objXMLHTTP = Nothing

End Function
